/*##CODE-DATEI
;-------------------------------------------------------------------------------
;##Copyright        :  ABB Automation Products GmbH
;
;-------------------------------------------------------------------------------
;##System           :  CONTRANS T
;##Systemkomponente :  Temperaturmessumformer TH02
;                      (Transmitter spez. Dokument: Rev. 1)
;-------------------------------------------------------------------------------
;##Programm         :  HC-DDL
;##Modul            :  TH02FS
;##Pfad/Datei       :  TH02FS.DDL
;##Library/Overlay  :  -/-
;##Programmierer    :  K.Pose / PLC-Alz
;##Erst.-Datum      :  02.03.2000
;##Version/Datum    :  01.00 / 02.03.2000
;-------------------------------------------------------------------------------
;##Beschreibung     :  Bearbeitung der Freistil - Kennlinie
;                      ACHTUNG : Laenderspezifische Texte noch hier
;
;##SPECEND
;-------------------------------------------------------------------------------
;###*/


#define VALID_CRV        TRUE;

#define CRV_TYPE_DEFX    {                               \
                              DISPLAY_FORMAT "6.3f";     \
                         }

#define CRV_TYPE_DEFY    {                               \
                              DISPLAY_FORMAT "6.3f";     \
                              EDIT_FORMAT   "6.3f";     \
                         }                              \
                         CONSTANT_UNIT [degC];

UNIT curve_value_X_relation
{
    sensor1_digital_units:

        CRV_X1, CRV_X2, CRV_X3, CRV_X4,
        CRV_X5, CRV_X6, CRV_X7, CRV_X8,
        CRV_X9, CRV_X10, CRV_X11, CRV_X12,
        CRV_X13, CRV_X14, CRV_X15, CRV_X16,
        CRV_X17, CRV_X18, CRV_X19, CRV_X20,
        CRV_X21, CRV_X22, CRV_X23, CRV_X24,
        CRV_X25, CRV_X26, CRV_X27, CRV_X28,
        CRV_X29, CRV_X30, CRV_X31, CRV_X32
}


VARIABLE CRV_X1
{
    LABEL  TXT_TIEPOINT_X01;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y1
{
    LABEL  TXT_TIEPOINT_Y01;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X2
{
    LABEL  TXT_TIEPOINT_X02;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y2
{
    LABEL  TXT_TIEPOINT_Y02;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X3
{
    LABEL  TXT_TIEPOINT_X03;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y3
{
    LABEL  TXT_TIEPOINT_Y03;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X4
{
    LABEL  TXT_TIEPOINT_X04;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y4
{
    LABEL  TXT_TIEPOINT_Y04;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X5
{
    LABEL  TXT_TIEPOINT_X05;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y5
{
    LABEL  TXT_TIEPOINT_Y05;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X6
{
    LABEL  TXT_TIEPOINT_X06;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y6
{
    LABEL  TXT_TIEPOINT_Y06;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X7
{
    LABEL  TXT_TIEPOINT_X07;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y7
{
    LABEL  TXT_TIEPOINT_Y07;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X8
{
    LABEL  TXT_TIEPOINT_X08;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y8
{
    LABEL  TXT_TIEPOINT_Y08;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X9
{
    LABEL  TXT_TIEPOINT_X09;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y9
{
    LABEL  TXT_TIEPOINT_Y09;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X10
{
    LABEL  TXT_TIEPOINT_X10;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y10
{
    LABEL  TXT_TIEPOINT_Y10;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X11
{
    LABEL  TXT_TIEPOINT_X11;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y11
{
    LABEL  TXT_TIEPOINT_Y11;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X12
{
    LABEL  TXT_TIEPOINT_X12;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y12
{
    LABEL  TXT_TIEPOINT_Y12;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X13
{
    LABEL  TXT_TIEPOINT_X13;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y13
{
    LABEL  TXT_TIEPOINT_Y13;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X14
{
    LABEL  TXT_TIEPOINT_X14;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y14
{
    LABEL  TXT_TIEPOINT_Y14;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X15
{
    LABEL  TXT_TIEPOINT_X15;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y15
{
    LABEL  TXT_TIEPOINT_Y15;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X16
{
    LABEL  TXT_TIEPOINT_X16;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y16
{
    LABEL  TXT_TIEPOINT_Y16;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X17
{
    LABEL  TXT_TIEPOINT_X17;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y17
{
    LABEL  TXT_TIEPOINT_Y17;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X18
{
    LABEL  TXT_TIEPOINT_X18;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y18
{
    LABEL  TXT_TIEPOINT_Y18;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X19
{
    LABEL  TXT_TIEPOINT_X19;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y19
{
    LABEL  TXT_TIEPOINT_Y19;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X20
{
    LABEL  TXT_TIEPOINT_X20;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y20
{
    LABEL  TXT_TIEPOINT_Y20;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X21
{
    LABEL  TXT_TIEPOINT_X21;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y21
{
    LABEL  TXT_TIEPOINT_Y21;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X22
{
    LABEL  TXT_TIEPOINT_X22;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y22
{
    LABEL  TXT_TIEPOINT_Y22;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X23
{
    LABEL  TXT_TIEPOINT_X23;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y23
{
    LABEL  TXT_TIEPOINT_Y23;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X24
{
    LABEL  TXT_TIEPOINT_X24;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y24
{
    LABEL  TXT_TIEPOINT_Y24;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X25
{
    LABEL  TXT_TIEPOINT_X25;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y25
{
    LABEL  TXT_TIEPOINT_Y25;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X26
{
    LABEL  TXT_TIEPOINT_X26;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y26
{
    LABEL  TXT_TIEPOINT_Y26;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X27
{
    LABEL  TXT_TIEPOINT_X27;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y27
{
    LABEL  TXT_TIEPOINT_Y27;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X28
{
    LABEL  TXT_TIEPOINT_X28;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y28
{
    LABEL  TXT_TIEPOINT_Y28;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X29
{
    LABEL  TXT_TIEPOINT_X29;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y29
{
    LABEL  TXT_TIEPOINT_Y29;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X30
{
    LABEL  TXT_TIEPOINT_X30;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y30
{
    LABEL  TXT_TIEPOINT_Y30;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X31
{
    LABEL  TXT_TIEPOINT_X31;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y31
{
    LABEL  TXT_TIEPOINT_Y31;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_X32
{
    LABEL  TXT_TIEPOINT_X32;
    HELP   HLP_TIEPOINT_X;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFX
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}
VARIABLE CRV_Y32
{
    LABEL  TXT_TIEPOINT_Y32;
    HELP   HLP_TIEPOINT_Y;
    CLASS  COMPUTATION;
    TYPE   FLOAT
    CRV_TYPE_DEFY
    VALIDITY  VALID_CRV
    HANDLING  READ & WRITE;
}


ARRAY OF VARIABLE curve_X
{
    LABEL TXT_CURVE_X;
    HELP  HLP_CURVE_X;

    ELEMENTS
    {
        1, CRV_X1 , TXT_TIEPOINT_X01,   HLP_TIEPOINT_X;
        2, CRV_X2 , TXT_TIEPOINT_X02,   HLP_TIEPOINT_X;
        3, CRV_X3 , TXT_TIEPOINT_X03,   HLP_TIEPOINT_X;
        4, CRV_X4 , TXT_TIEPOINT_X04,   HLP_TIEPOINT_X;
        5, CRV_X5 , TXT_TIEPOINT_X05,   HLP_TIEPOINT_X;
        6, CRV_X6 , TXT_TIEPOINT_X06,   HLP_TIEPOINT_X;
        7, CRV_X7 , TXT_TIEPOINT_X07,   HLP_TIEPOINT_X;
        8, CRV_X8 , TXT_TIEPOINT_X08,   HLP_TIEPOINT_X;
        9, CRV_X9 , TXT_TIEPOINT_X09,   HLP_TIEPOINT_X;
       10, CRV_X10, TXT_TIEPOINT_X10,   HLP_TIEPOINT_X;
       11, CRV_X11, TXT_TIEPOINT_X11,   HLP_TIEPOINT_X;
       12, CRV_X12, TXT_TIEPOINT_X12,   HLP_TIEPOINT_X;
       13, CRV_X13, TXT_TIEPOINT_X13,   HLP_TIEPOINT_X;
       14, CRV_X14, TXT_TIEPOINT_X14,   HLP_TIEPOINT_X;
       15, CRV_X15, TXT_TIEPOINT_X15,   HLP_TIEPOINT_X;
       16, CRV_X16, TXT_TIEPOINT_X16,   HLP_TIEPOINT_X;
       17, CRV_X17, TXT_TIEPOINT_X17,   HLP_TIEPOINT_X;
       18, CRV_X18, TXT_TIEPOINT_X18,   HLP_TIEPOINT_X;
       19, CRV_X19, TXT_TIEPOINT_X19,   HLP_TIEPOINT_X;
       20, CRV_X20, TXT_TIEPOINT_X20,   HLP_TIEPOINT_X;
       21, CRV_X21, TXT_TIEPOINT_X21,   HLP_TIEPOINT_X;
       22, CRV_X22, TXT_TIEPOINT_X22,   HLP_TIEPOINT_X;
       23, CRV_X23, TXT_TIEPOINT_X23,   HLP_TIEPOINT_X;
       24, CRV_X24, TXT_TIEPOINT_X24,   HLP_TIEPOINT_X;
       25, CRV_X25, TXT_TIEPOINT_X25,   HLP_TIEPOINT_X;
       26, CRV_X26, TXT_TIEPOINT_X26,   HLP_TIEPOINT_X;
       27, CRV_X27, TXT_TIEPOINT_X27,   HLP_TIEPOINT_X;
       28, CRV_X28, TXT_TIEPOINT_X28,   HLP_TIEPOINT_X;
       29, CRV_X29, TXT_TIEPOINT_X29,   HLP_TIEPOINT_X;
       30, CRV_X30, TXT_TIEPOINT_X30,   HLP_TIEPOINT_X;
       31, CRV_X31, TXT_TIEPOINT_X31,   HLP_TIEPOINT_X;
       32, CRV_X32, TXT_TIEPOINT_X32,   HLP_TIEPOINT_X;
    }
}

ARRAY OF VARIABLE curve_Y
{
    LABEL TXT_CURVE_Y;
    HELP  HLP_CURVE_Y;

    ELEMENTS
    {
        1, CRV_Y1 , TXT_TIEPOINT_Y01,   HLP_TIEPOINT_Y;
        2, CRV_Y2 , TXT_TIEPOINT_Y02,   HLP_TIEPOINT_Y;
        3, CRV_Y3 , TXT_TIEPOINT_Y03,   HLP_TIEPOINT_Y;
        4, CRV_Y4 , TXT_TIEPOINT_Y04,   HLP_TIEPOINT_Y;
        5, CRV_Y5 , TXT_TIEPOINT_Y05,   HLP_TIEPOINT_Y;
        6, CRV_Y6 , TXT_TIEPOINT_Y06,   HLP_TIEPOINT_Y;
        7, CRV_Y7 , TXT_TIEPOINT_Y07,   HLP_TIEPOINT_Y;
        8, CRV_Y8 , TXT_TIEPOINT_Y08,   HLP_TIEPOINT_Y;
        9, CRV_Y9 , TXT_TIEPOINT_Y09,   HLP_TIEPOINT_Y;
       10, CRV_Y10, TXT_TIEPOINT_Y10,   HLP_TIEPOINT_Y;
       11, CRV_Y11, TXT_TIEPOINT_Y11,   HLP_TIEPOINT_Y;
       12, CRV_Y12, TXT_TIEPOINT_Y12,   HLP_TIEPOINT_Y;
       13, CRV_Y13, TXT_TIEPOINT_Y13,   HLP_TIEPOINT_Y;
       14, CRV_Y14, TXT_TIEPOINT_Y14,   HLP_TIEPOINT_Y;
       15, CRV_Y15, TXT_TIEPOINT_Y15,   HLP_TIEPOINT_Y;
       16, CRV_Y16, TXT_TIEPOINT_Y16,   HLP_TIEPOINT_Y;
       17, CRV_Y17, TXT_TIEPOINT_Y17,   HLP_TIEPOINT_Y;
       18, CRV_Y18, TXT_TIEPOINT_Y18,   HLP_TIEPOINT_Y;
       19, CRV_Y19, TXT_TIEPOINT_Y19,   HLP_TIEPOINT_Y;
       20, CRV_Y20, TXT_TIEPOINT_Y20,   HLP_TIEPOINT_Y;
       21, CRV_Y21, TXT_TIEPOINT_Y21,   HLP_TIEPOINT_Y;
       22, CRV_Y22, TXT_TIEPOINT_Y22,   HLP_TIEPOINT_Y;
       23, CRV_Y23, TXT_TIEPOINT_Y23,   HLP_TIEPOINT_Y;
       24, CRV_Y24, TXT_TIEPOINT_Y24,   HLP_TIEPOINT_Y;
       25, CRV_Y25, TXT_TIEPOINT_Y25,   HLP_TIEPOINT_Y;
       26, CRV_Y26, TXT_TIEPOINT_Y26,   HLP_TIEPOINT_Y;
       27, CRV_Y27, TXT_TIEPOINT_Y27,   HLP_TIEPOINT_Y;
       28, CRV_Y28, TXT_TIEPOINT_Y28,   HLP_TIEPOINT_Y;
       29, CRV_Y29, TXT_TIEPOINT_Y29,   HLP_TIEPOINT_Y;
       30, CRV_Y30, TXT_TIEPOINT_Y30,   HLP_TIEPOINT_Y;
       31, CRV_Y31, TXT_TIEPOINT_Y31,   HLP_TIEPOINT_Y;
       32, CRV_Y32, TXT_TIEPOINT_Y32,   HLP_TIEPOINT_Y;
    }
}


COMMAND read_curve
{
    NUMBER 142;

    OPERATION READ;

    TRANSACTION 1
    {
        REQUEST
        { 0 }
        REPLY
        {
            response_code, device_status,
            0,
            CRV_X1,CRV_Y1,
            CRV_X2,CRV_Y2,
            CRV_X3,CRV_Y3
        }
    }
    TRANSACTION 2
    {
        REQUEST
        { 3 }
        REPLY
        {
            response_code, device_status,
            3,
            CRV_X4,CRV_Y4,
            CRV_X5,CRV_Y5,
            CRV_X6,CRV_Y6
        }
    }
    TRANSACTION 3
    {
        REQUEST
        { 6 }
        REPLY
        {
            response_code, device_status,
            6,
            CRV_X7,CRV_Y7,
            CRV_X8,CRV_Y8,
            CRV_X9,CRV_Y9
        }
    }
    TRANSACTION 4
    {
        REQUEST
        { 9 }
        REPLY
        {
            response_code, device_status,
            9,
            CRV_X10,CRV_Y10,
            CRV_X11,CRV_Y11,
            CRV_X12,CRV_Y12
        }
    }
    TRANSACTION 5
    {
        REQUEST
        { 12 }
        REPLY
        {
            response_code, device_status,
            12,
            CRV_X13,CRV_Y13,
            CRV_X14,CRV_Y14,
            CRV_X15,CRV_Y15
        }
    }
    TRANSACTION 6
    {
        REQUEST
        { 15 }
        REPLY
        {
            response_code, device_status,
            15,
            CRV_X16,CRV_Y16,
            CRV_X17,CRV_Y17,
            CRV_X18,CRV_Y18
        }
    }
    TRANSACTION 7
    {
        REQUEST
        { 18 }
        REPLY
        {
            response_code, device_status,
            18,
            CRV_X19,CRV_Y19,
            CRV_X20,CRV_Y20,
            CRV_X21,CRV_Y21
        }
    }
    TRANSACTION 8
    {
        REQUEST
        { 21 }
        REPLY
        {
            response_code, device_status,
            21,
            CRV_X22,CRV_Y22,
            CRV_X23,CRV_Y23,
            CRV_X24,CRV_Y24
        }
    }
    TRANSACTION 9
    {
        REQUEST
        { 24 }
        REPLY
        {
            response_code, device_status,
            24,
            CRV_X25,CRV_Y25,
            CRV_X26,CRV_Y26,
            CRV_X27,CRV_Y27
        }
    }
    TRANSACTION 10
    {
        REQUEST
        { 27 }
        REPLY
        {
            response_code, device_status,
            27,
            CRV_X28,CRV_Y28,
            CRV_X29,CRV_Y29,
            CRV_X30,CRV_Y30
        }
    }
    TRANSACTION 11
    {
        REQUEST
        { 29 }
        REPLY
        {
            response_code, device_status,
            29,
            0,0,0,0,0,0,0,0,
            CRV_X31,CRV_Y31,
            CRV_X32,CRV_Y32
        }
    }

    RESPONSE_CODES
    {
        0,  SUCCESS,                  [no_command_specific_errors];
        2,  DATA_ENTRY_ERROR,         [invalid_selection];
        5,  MISC_ERROR,               [too_few_data_bytes_recieved];
        6,  MODE_ERROR,               [xmtr_specific_command_error];
    }
}

COMMAND write_curve
{
    NUMBER 143;

    OPERATION WRITE;

    TRANSACTION 1
    {
        REQUEST
        {
            0,
            CRV_X1,CRV_Y1,
            CRV_X2,CRV_Y2,
            CRV_X3,CRV_Y3
        }
        REPLY
        {
            response_code, device_status,
            0,
            CRV_X1,CRV_Y1,
            CRV_X2,CRV_Y2,
            CRV_X3,CRV_Y3
        }
    }
    TRANSACTION 2
    {
        REQUEST
        {
            3,
            CRV_X4,CRV_Y4,
            CRV_X5,CRV_Y5,
            CRV_X6,CRV_Y6
        }
        REPLY
        {
            response_code, device_status,
            3,
            CRV_X4,CRV_Y4,
            CRV_X5,CRV_Y5,
            CRV_X6,CRV_Y6
        }
    }
    TRANSACTION 3
    {
        REQUEST
        {
            6,
            CRV_X7,CRV_Y7,
            CRV_X8,CRV_Y8,
            CRV_X9,CRV_Y9
        }
        REPLY
        {
            response_code, device_status,
            6,
            CRV_X7,CRV_Y7,
            CRV_X8,CRV_Y8,
            CRV_X9,CRV_Y9
        }
    }
    TRANSACTION 4
    {
        REQUEST
        {
            9,
            CRV_X10,CRV_Y10,
            CRV_X11,CRV_Y11,
            CRV_X12,CRV_Y12
        }
        REPLY
        {
            response_code, device_status,
            9,
            CRV_X10,CRV_Y10,
            CRV_X11,CRV_Y11,
            CRV_X12,CRV_Y12
        }
    }
    TRANSACTION 5
    {
        REQUEST
        {
            12,
            CRV_X13,CRV_Y13,
            CRV_X14,CRV_Y14,
            CRV_X15,CRV_Y15
        }
        REPLY
        {
            response_code, device_status,
            12,
            CRV_X13,CRV_Y13,
            CRV_X14,CRV_Y14,
            CRV_X15,CRV_Y15
        }
    }
    TRANSACTION 6
    {
        REQUEST
        {
            15,
            CRV_X16,CRV_Y16,
            CRV_X17,CRV_Y17,
            CRV_X18,CRV_Y18
        }
        REPLY
        {
            response_code, device_status,
            15,
            CRV_X16,CRV_Y16,
            CRV_X17,CRV_Y17,
            CRV_X18,CRV_Y18
        }
    }
    TRANSACTION 7
    {
        REQUEST
        {
            18,
            CRV_X19,CRV_Y19,
            CRV_X20,CRV_Y20,
            CRV_X21,CRV_Y21
        }
        REPLY
        {
            response_code, device_status,
            18,
            CRV_X19,CRV_Y19,
            CRV_X20,CRV_Y20,
            CRV_X21,CRV_Y21
        }
    }
    TRANSACTION 8
    {
        REQUEST
        {
            21,
            CRV_X22,CRV_Y22,
            CRV_X23,CRV_Y23,
            CRV_X24,CRV_Y24
        }
        REPLY
        {
            response_code, device_status,
            21,
            CRV_X22,CRV_Y22,
            CRV_X23,CRV_Y23,
            CRV_X24,CRV_Y24
        }
    }
    TRANSACTION 9
    {
        REQUEST
        {
            24,
            CRV_X25,CRV_Y25,
            CRV_X26,CRV_Y26,
            CRV_X27,CRV_Y27
        }
        REPLY
        {
            response_code, device_status,
            24,
            CRV_X25,CRV_Y25,
            CRV_X26,CRV_Y26,
            CRV_X27,CRV_Y27
        }
    }
    TRANSACTION 10
    {
        REQUEST
        {
            27,
            CRV_X28,CRV_Y28,
            CRV_X29,CRV_Y29,
            CRV_X30,CRV_Y30
        }
        REPLY
        {
            response_code, device_status,
            27,
            CRV_X28,CRV_Y28,
            CRV_X29,CRV_Y29,
            CRV_X30,CRV_Y30
        }
    }
    TRANSACTION 11
    {
        REQUEST
        {
            29,
            CRV_X30,CRV_Y30,
            CRV_X31,CRV_Y31,
            CRV_X32,CRV_Y32
        }
        REPLY
        {
            response_code, device_status,
            29,
            CRV_X30,CRV_Y30,
            CRV_X31,CRV_Y31,
            CRV_X32,CRV_Y32
        }
    }

    RESPONSE_CODES
    {
        0,  SUCCESS,                  [no_command_specific_errors];
        2,  DATA_ENTRY_ERROR,         [invalid_selection];
        5,  MISC_ERROR,               [too_few_data_bytes_recieved];
        6,  MODE_ERROR,               [xmtr_specific_command_error];
        7,  MODE_ERROR,               [in_write_protect_mode];
        12, DATA_ENTRY_ERROR,         TXT_CURVEX_ERROR;
    }
}


METHOD edit_curve
{
    LABEL TXT_EDIT_CURVE;
    HELP  HLP_EDIT_CURVE;
    DEFINITION
    {
        int idx;
        int eflag;
        int yflag;
        int counter;
        float tmp;
        float tmp_X;
        float tmp_Y;
        float C_Mul;
        float C_Add;
        long ids[2];
        int result;

        char  status     [STATUS_SIZE];
        char  xmtr_status[MAX_XMTR_STATUS_LEN];

        if( ivar_value( sensor_typ ) != 2 )
        {
            ACKNOWLEDGE( TXT_CURVE_NO_EDIT );
            process_abort();
        }


        IGNORE_ALL_DEVICE_STATUS();          /* Stoerungen werden vom HHT nur  */

        XMTR_IGNORE_ALL_DEVICE_STATUS();     /* Umstellen auf eigene          */
                                             /* Meldungen.                    */
        XMTR_IGNORE_ALL_RESPONSE_CODES();   /* zurueckkommenden Response Code  */
                                            /* Bytes                          */

        DELAY(1,TXT_CURVE_READ);
        counter=1;
        do
        {
           send_command_trans( 142,  counter );
           if( status[STATUS_RESPONSE_CODE] )
           {
               display_response_status( 142,status[STATUS_RESPONSE_CODE] );
               ACKNOWLEDGE( TXT_CURVE_READ_ERROR );
               process_abort();
           }
        }
        while (counter++ < 11 );

        idx=1;
        eflag=0;
        ids[0]=VARID(sensor1_digital_units);
        ids[1]=VARID( PV.DIGITAL_UNITS );

        C_Mul = 1;
        C_Add = 0;

        switch ( ivar_value( PV.DIGITAL_UNITS ) )
        {
            case 33:    /* Fahrenheit */
                C_Mul = 1.8;
                C_Add = 32;
                break;
            case 34:    /* Rankine */
                C_Mul = 1.8;
                C_Add = 491.67;
                break;
            case 35:    /* Kelvin */
                C_Add = 273.15;
        }                                

        do
        {
            tmp_X=fvar_value(curve_X[idx]);
            tmp_Y=C_Add + fvar_value(curve_Y[idx])* C_Mul;

            result=select_from_list( VXT_CURVEV_PROMPT ,ids ,VXT_CURVEV_SELECT );

            if( result == 0 && idx < 32 )
            {
                idx++;
            }
            if( result == 1 && idx > 1 )
            {
                idx--;
            }
            if( result == 2 )
            {
                /* EDIT */

                get_local_var_value( VXT_CURVEE_X , ids, tmp_X);
                fassign(curve_X[idx],tmp_X);

                get_local_var_value(VXT_CURVEE_Y , ids, tmp_Y);

                tmp_Y = ( tmp_Y - C_Add ) / C_Mul;
                fassign(curve_Y[idx],tmp_Y);

            } /* EditEnd */

            if ( result == 3 )
            {
                /* Write to Device */

                counter=2;
                yflag=0;
                do
                {
                    if ( fvar_value(curve_X[counter]) <= fvar_value(curve_X[counter-1]) )
                    {
                        /* X-Werte nicht streng monoton steigend */
                        ACKNOWLEDGE(TXT_CURVEX_ERROR);
                        yflag=3;
                        break;
                    }
                    if ( fvar_value(curve_Y[counter]) < fvar_value(curve_Y[counter-1]) )
                    {
                        /* Y-Werte fallend */
                        if ( yflag==2 )
                        {
                            ACKNOWLEDGE(TXT_CURVEY_ERROR);
                            yflag=4;
                            break;
                        }
                        yflag=1;
                    }
                    else if ( fvar_value(curve_Y[counter]) > fvar_value(curve_Y[counter-1]) )
                    {
                        /* Y-Werte steigend */
                        if ( yflag==1 )
                        {
                            ACKNOWLEDGE(TXT_CURVEY_ERROR);
                            yflag=4;
                            break;
                        }
                        yflag=2;
                    }
                    else
                    {
                        /* Y-Werte sind gleich */
                        ACKNOWLEDGE(TXT_CURVEY_ERROR);
                        yflag=4;
                        break;
                    }
                }
                while ( counter++ < 32 );

                if ( yflag < 3 )
                {
                    /* Curve is OK, send it */

                    if( eflag==0 )
                    {
                        add_abort_method(reset_parameter);
                        /* letzte Chance fuer einen Abbruch */
                        /* bzw. fehlerhafte Kennl. im RAM */
                        eflag=1;
                    }

                    DELAY(1,TXT_CURVE_WRITE);

                    counter=1;
                    do
                    {
                        send_trans( 143,  counter , status );
                        if( status[STATUS_RESPONSE_CODE] )
                        {
                            display_response_status( 143,status[STATUS_RESPONSE_CODE] );
                            ACKNOWLEDGE( TXT_CURVE_WRITE_ERROR );
                            yflag=10;
                            break;
                        }
                    }
                    while (counter++ < 11 );

                    if(yflag<10)
                    {
                        /* ---------------------------------------------------------- */
                        /*  Schreiben war erfolgreich, nun muessen die Daten noch       */
                        /*  netzausfallsicher gespeichert werden, damit nicht alles   */
                        /*  fuer die Katz' war...                                      */
                        /* ---------------------------------------------------------- */

                        DELAY( 2,TXT_EEPROM_WAIT );                /* Bitte warten... */

                        remove_all_abort_methods();

                        iassign(eeprom_select,0);                   /* EEPROM brennen */
                        send(39,status);

                        if( status[STATUS_RESPONSE_CODE] )
                        {
                            /* Daten konnten nicht gebrannt werden */
                            display_response_status(39,status[STATUS_RESPONSE_CODE]);
                            ACKNOWLEDGE( TXT_EEPROM_NO_SAVE );
                        }
                        else
                        {
                            /*
                             *  bis hierher Standard, aber das RESET-Bit sollte noch
                             *  geloescht werden...
                             */
        
                            counter = 0;
                            do
                            {
                                /*
                                 *  Kommando #48 ausfuehren, bis eine
                                 *  Antwort kommt...
                                 */
        
                                send(48,status);
                            }
                            while( (status[STATUS_RESPONSE_CODE] == DEVICE_BUSY) && (counter++ < 10) );
                            ACKNOWLEDGE(TXT_CURVE_WRITTEN);
                            process_abort();
                        } /* Reset clear */
                    } /* Burn OK */
                } /* Plausi OK */
            } /* WriteEnd */
        } /* HauptschleifeEnd */
        while ( 1 );
    } /* DefEnd */
} /* MethodEnd */

