/*##CODE-DATEI
;-------------------------------------------------------------------------------
; ##Copyright        :  ABB Automation Products GmbH
;
;-------------------------------------------------------------------------------
; ##System           :  CONTRANS T
; ##Systemkomponente :  Temperaturmessumformer TH02
;                       (Transmitter spez. Dokument: Rev. 1)
;-------------------------------------------------------------------------------
; ##Programm         :  HC-DDL
; ##Modul            :  TH02ME
; ##Pfad/Datei       :  TH02ME.DDL
; ##Library/Overlay  :  -/-
; ##Programmierer    :  K.Pose / PLC-Alz
; ##Erst.-Datum      :  02.03.2000
; ##Version/Datum    :  01.00 / 02.03.2000
;-------------------------------------------------------------------------------
; ##Beschreibung     :  Definition der Menuestruktur zur Benutzerfuehrung im
;                       HHT275.
;
; ##SPECEND
;-------------------------------------------------------------------------------
;###*/

/*******************************************************************************/
/*****	Upload / Download  *****************************************************/
/*******************************************************************************/

MENU upload_variables  /* schreiben in Feldgraet */
{
	LABEL  TXT_UPLOAD_VARS;
	ITEMS
	{
		/* Messstellen-Daten */
		tag,
		descriptor,
		message,
		date,
		sensor_typ,
		n_sensor,
		messart,
		wire_no,
		sensor_monitor,
		final_assembly_number,
		primary_measurement_lower_range_value,
		primary_measurement_upper_range_value,
		digital_units,
		primary_measurement_damping_value,
		sensor_serial_number,
		sensor_name,
		polling_address,
		usr_threshold1,
		usr_threshold2,
		alter_value,
		alter_selector,
		out_select,
		out_under,
		out_over
	}
}

MENU download_variables  /* lesen aus Feldgert */
{
	LABEL str_download_variables_menu;
	ITEMS
	{
		tag,
		descriptor,
		message,
		date,
		final_assembly_number,
		private_label_distributor,
		sensor_serial_number,
		digital_units,
		write_protect,
//		_version,
		primary_measurement_digital_value,
		primary_measurement_percent_range,
		ma_analog_output_value,
		sensor1_measurement_digital_value,
		electronics_temperature_digital_value,
		primary_measurement_lower_range_value,
		primary_measurement_upper_range_value,
		primary_measurement_lower_sensor_limit,
		primary_measurement_upper_sensor_limit,
		digital_units,
		primary_measurement_damping_value,
		primary_measurement_minimum_span,
		primary_measurement_damping_value,
		sensor_typ,
		ma_analog_output_value,
		sensor_serial_number,
		sensor_name,
		n_sensor,
		messart,
		wire_no,
		sensor_monitor,
		out_select,
		out_under,
		out_over,
		alter_selector,
		physical_signaling_code,
//		polling_address,
		request_preambles,
		usr_threshold1,
		usr_threshold2,
		manufacturer_id,
		device_type,
		device_id,
		universal_revision,
		transmitter_revision,
		hardware_revision,
		software_revision,
		alter_value
	}
}

/*VARIABLE  _version
{
    LABEL    TXT_VERSION;
    CLASS    LOCAL;
    HANDLING READ;

    TYPE ENUMERATED
    {
        { 0, TXT_LANGUAGE, HLP_LANGUAGE }
    }
}

*/